#include "V3.h"
#include <iostream.h>
#include <math.h>

#define RD  57.29578       /* RAD TO DEG CONVERSION */
#define DR  0.0174532925199/* DEG TO RAD CONVERSION */

 ClassImp(V3)

// 3-VECTOR
V3::V3(){
SetV3(0.,0.,0.);
}
V3::V3(double x , double y , double z ){
  SetV3(x,y,z);
}
V3::~V3(){
}
//set the vector if the coordinate are given
void V3::SetV3(double x , double y , double z ){
  SetX(x);
  SetY(y);
  SetZ(z);
}
//set sigle coordinates
void V3::SetX(double x){
xx=x;
}
void V3::SetY(double y){
yy=y;
}
void V3::SetZ(double z){
zz=z;
}
//set the vector with mod the and phi given. ANGLES MUST BE GIVEN IN RAD
void V3::SetV3_sphe(double mod , double the , double phi ){
  xx=mod*sin(the)*cos(phi);
  yy=mod*sin(the)*sin(phi);
  zz=mod*cos(the);
}
//get sigle coordinates
double V3::GetX(){
return xx;
}
double V3::GetY(){
return yy;
}
double V3::GetZ(){
return zz;
}
//modulus
double V3::Mod(){
return sqrt(xx*xx+yy*yy+zz*zz);
}
//calculate the 0 - 3.14
double V3::The(){
return acos(zz/Mod());
}
//calculate phi -3.14 - 3.14
double V3::Phi(){
return atan2(yy,xx);
}
//print 3-vector
void V3::Print(){
  cout<<"x="<<xx<<" y="<<yy<<" z="<<zz<<" the="<<The()*RD<<" phi="<<Phi()*RD<<" mod="<<Mod()<<endl;
}
//overloading + and - operators
V3 V3::operator+(V3 obj2){
V3 temp;
temp.xx=xx+obj2.xx;
temp.yy=yy+obj2.yy;
temp.zz=zz+obj2.zz;
return temp;
}
V3 V3::operator-(V3 obj2){
V3 temp;
temp.xx=xx-obj2.xx;
temp.yy=yy-obj2.yy;
temp.zz=zz-obj2.zz;
return temp;
}
//vector product - overloading ^ operator
V3 V3::operator^(V3 obj2){
V3 temp;
temp.xx=yy*obj2.zz-zz*obj2.yy;
temp.yy=-(xx*obj2.zz-zz*obj2.xx);
temp.zz=xx*obj2.yy-yy*obj2.xx;
return temp;
}
//scalar product overloading * operator
double V3::operator*(V3 obj2){
return xx*obj2.xx+yy*obj2.yy+zz*obj2.zz;
}
//Rotation is around rotax,of an angle omega counter-clockwise,it returns vprime vector
V3 V3::Rotation(double omega,V3 rotax){  
V3 vprime;
  double v[3]={xx,yy,zz};
  double vfinal[3]={0,0,0};
double rotm[3][3];
  //Definition of he rotation matrix

rotm[0][0]=rotax.GetX()*rotax.GetX()*(1-cos(omega))+cos(omega);
rotm[0][1]=rotax.GetZ()*sin(omega)+(1-cos(omega))*rotax.GetX()*rotax.GetY();
rotm[0][2]=-rotax.GetY()*sin(omega)+(1-cos(omega))*rotax.GetX()*rotax.GetZ();
rotm[1][0]=-rotax.GetZ()*sin(omega)+(1-cos(omega))*rotax.GetX()*rotax.GetY();
rotm[1][1]=rotax.GetY()*rotax.GetY()*(1-cos(omega))+cos(omega);
rotm[1][2]=rotax.GetX()*sin(omega)+(1-cos(omega))*rotax.GetY()*rotax.GetZ();
rotm[2][0]=rotax.GetY()*sin(omega)+(1-cos(omega))*rotax.GetX()*rotax.GetZ();
rotm[2][1]=-rotax.GetX()*sin(omega)+(1-cos(omega))*rotax.GetY()*rotax.GetZ();
rotm[2][2]=rotax.GetZ()*rotax.GetZ()*(1-cos(omega))+cos(omega);


  for(int i=0;i<3;i++){
    for(int j=0;j<3;j++){
      vfinal[i]=vfinal[i]+rotm[i][j]*v[j];
    }
  }

vprime.SetV3(vfinal[0],vfinal[1],vfinal[2]);
return vprime;
}
V3 V3::Scale(double cost){
V3 temp;
temp.xx=cost*xx;
temp.yy=cost*yy;
temp.zz=cost*zz;
return temp;
}
V3 operator*( double a,V3 v){
V3 tmp;
tmp.xx=v.xx*a;
tmp.yy=v.yy*a;
tmp.zz=v.zz*a;
return tmp;
;}
V3 operator*( V3 v,double a){
V3 tmp;
tmp.xx=v.xx*a;
tmp.yy=v.yy*a;
tmp.zz=v.zz*a;
return tmp;
//a*v;  
}
