#ifndef V4_H
#define V4_H

#include "TObject.h"
#include "V3.h"


class V4 : public TObject {
 public:

  V4();
  V4( double,double ,double , double );
  V4( V3 , double );
  V4(double,V3);
  virtual ~V4(); 
  

  void SetV4(V3,double);
  void SetV4(double,double ,double,double);
  void SetX(double);
  void SetY(double);
  void SetZ(double);
  void SetT(double);

  void Print();
  
  double GetX();
  double GetY();
  double GetZ();
  double GetT();
  V3 GetV();

  double Mod();

  //  void SetV(double,double,double);
  void SetV(V3);

  V4 Lorentz(V3);

  V4 operator+(V4);
  V4 operator-(V4);
  
  //angle in radiants
  V4 Rotation(double,V3);

 private:
  V3 vv;  
  double tt;
  ClassDef(V4,1)
};
#endif
